/*****************************************************
* ڐG]vO
* I2CtɃpX(H̖)ݒlA](rpm)\
* GPIO3(s4)pXύX{^
* GPIO5(s2)z[h{^
******************************************************/
#include <xc.h>
#include  "lcd_i2c_lib.h"

/***** RtBM[V̐ݒ ********/
#pragma config FOSC=INTOSCIO
#pragma config WDTE=OFF
#pragma config PWRTE=ON
#pragma config BOREN=OFF
#pragma config MCLRE=OFF
#pragma config CP=OFF
#pragma config CPD=OFF
#pragma config FCMEN=OFF


#define EEaddress 0xFF
#define DEVIDEBASE_7 17142857L
#define DEVIDEBASE_5 24000000L
#define DEVIDEBASE_2 60000000L 
#define CASENUMMAX 2

#define IrPort			GPIObits.GP2
#define BladesButtonPort	GPIObits.GP3
#define HoldButtonPort		GPIObits.GP5
#define LEDPort				GPIObits.GP4
#define buttonPressed	0
#define Low				0


/* ֐vg^CsO  */
void switch_Blades_num(unsigned char num);
void interrupt Interrupt(void);
void ltostring(char digit, unsigned short long data, char *buffer);

/* O[oϐ@*/
unsigned char bladesMsg[] = "blades";
unsigned char revMsg[] = "rev";
unsigned char ClrMsg[] = "     ";
unsigned char BufferMsg[6];

unsigned int hold_timer1 = 0;		//Lv`荞ݎ̃^C}P
unsigned int pre_hold_timer1 = 0;	//^C}P̑Ol
unsigned int diff_hold_timer1 = 65535;	//(hold_timer1 - pre_hold_timer1)ۑ
unsigned long value;
unsigned long devidebase = 0;
unsigned char too_slow = 0;
unsigned char buttonCount_bl = 0;
unsigned char buttonCount_hd = 0;
unsigned char casenum;
unsigned char hold = 0;
unsigned char temp_counter = 20;
char PulseMulti = '2';
char EEdata = 0;


void switch_Blades_num(unsigned char num)
{
	switch (num){
		case 0:
			PulseMulti='2';
			devidebase = DEVIDEBASE_2;
			break;
		case 1:
			PulseMulti='5';
			devidebase = DEVIDEBASE_5;
			break;
		case 2:
			PulseMulti='7';
			devidebase = DEVIDEBASE_7;
			break;
		default:
			break;
	}
}

void interrupt Interrupt(void)
{
	if(PIR1bits.CCP1IF)
	{	//Lv`1荞
		PIR1bits.CCP1IF = 0;
		pre_hold_timer1 = hold_timer1;
		hold_timer1 = (CCPR1H << 8) | CCPR1L;
		diff_hold_timer1 = hold_timer1 - pre_hold_timer1;

		TMR2 = 50;		// TMR2CCP11zȂ`FbÑׂJE^Bl50ɂ邱Ƃŏ]TČmł
		too_slow = 0;	// CCP1Timer2͓Ȃ̂łCCP1mł
	}


	if(PIR1bits.TMR2IF)
	{	//Timer2荞
		PIR1bits.TMR2IF = 0;

		too_slow = 1;	// CCP11Timer21Ƃ͓Ȃ̂łCCP1mł


		if(casenum != (unsigned char)EEdata)
		{
			EEdata = (char)casenum;
			eeprom_write(EEaddress, EEdata);

			switch_Blades_num(casenum);
		}
	}


	if(INTCONbits.T0IF)
	{	//Timer0荞
		INTCONbits.T0IF = 0;

		if (BladesButtonPort == buttonPressed)
		{
			if(buttonCount_bl != 1)
			{
				if(buttonCount_bl != 0)
				{
					buttonCount_bl--;
				}
				else
				{
					buttonCount_bl = 8;
				}

				if(buttonCount_bl == 1){
					casenum++;
					if(casenum>CASENUMMAX)
						casenum = 0;
				}
			}
		}
		else
		{
			if(buttonCount_bl != 0)
			{
				buttonCount_bl = 0;
			}
		}

		if (HoldButtonPort == buttonPressed)
		{
			if(buttonCount_hd != 1)
			{
				if(buttonCount_hd != 0)
				{
					buttonCount_hd--;
				}
				else
				{
					buttonCount_hd = 8;
				}

				if(buttonCount_hd == 1){
					// Toggle hold
					hold++;
					if(hold>1)
						hold = 0;
				}
			}
		}
		else
		{
			if(buttonCount_hd != 0)
			{
				buttonCount_hd = 0;
			}
		}

		if(IrPort == Low)
			LEDPort = 1;
		else
			LEDPort = 0;
	}

}



/****************** C֐ ********************/
void main(void)
{
	unsigned int i;

	OSCCON = 0b01110000;		// 8MHzɐݒ
	TRISIO = 0b00101100;		// GPIO2,GPIO3,GPIO5͐ݒ
	CMCON0 = 0b00000111;		// Rp[^It

	ANSEL = 0b01011000;			// A/D Conversion Clock Select bits FOSC/16 ANSEL = ANS3(ANALOG ON), ANS2`0 (ANALOG OFF)

	WPU = 0b00100000;			// Pull up GPIO5

	OPTION_REG = 0b00000000;	// GPIO pull-ups are enabled




	// CCP1֘A
	PIE1bits.TMR1IE = 0;		// TMR1I[o[t[荞݋֎~
	PIE1bits.CCP1IE = 1;		// Enables the CCP1 interrupt
	TMR1H = 0;
	TMR1L = 0;
	T1CON = 0b00000001;			// Prescaller 1:1,internal clock, start timer1
	CCP1CON = 0b00000101;		// Capture mode, every rising edge




	// Timer2֘A
	TMR2 = 0;		// TMR2CCP11zȂ`FbÑׂJE^
	T2CON = 0b01111110;			// Postscaler=16,Prescaler=16,TMR2=ON
	PIE1bits.TMR2IE = 1;		// TMR2荞݂Enable




	// Timer0֘A
	OPTION_REGbits.T0CS = 0;	// TMR0 Clock Source Select bit = Internal instruction cycle clock
	OPTION_REGbits.PSA = 0;		// Prescaler Assignment bit = Prescaler is assigned to the Timer0 module
	OPTION_REG &= (0b11111000 | 0b00000011);	// Prescaler=1:16(2msɃIo[t[)
	INTCONbits.T0IE = 1;		// TMR0 Overflow Interrupt Enable bita = Enables the TMR0 interrupt




	// EEPROMǂݏo
	EEdata = eeprom_read(EEaddress);
	casenum = (unsigned char)EEdata;
	if(casenum>CASENUMMAX)
		casenum = 0;

	switch_Blades_num(casenum);



	lcd_init();						// t\̏
	lcd_clear();					// S



	lcd_posyx(0,0);					// 1sڎw
	lcd_str(bladesMsg);
	lcd_posyx(1,0);					// 2sڎw
	lcd_str(revMsg);




	INTCONbits.INTE = 0;		// GPIO2̊O݂Disable
	INTCONbits.PEIE = 1;		// ӊ荞݂̋
	INTCONbits.GIE = 1;			// S̊荞݂̋





	/************* C[v **************/
	while(1)
	{
		lcd_posyx(0,7);
		lcd_data(PulseMulti);


		__delay_ms(20);


		if(!(--temp_counter))
		{
			if(!hold)
			{
				if(too_slow)
					value = 99999;
				else
					value = devidebase / diff_hold_timer1;

				if(value == 99999)
				{
					lcd_posyx(1,3);
					lcd_str(ClrMsg);
				}
				else
				{
					ltostring(5, value, BufferMsg);
					lcd_posyx(1,3);
					lcd_str(BufferMsg);
				}
			}

			temp_counter = 20;
		}

	}
}
/***************************************
* ASCIIɕϊ
****************************************/
void ltostring(char digit, unsigned short long data, char *buffer){
	char i;

	buffer += digit;						// Ō̐ʒu
	for(i=digit; i>0; i--) {				// ϊ͉ʂʂ
		buffer--;						// |C^[P
		*buffer = (data % 10) + '0';		// ASCII
		data = data / 10;					// ̌
	}
}
